function T = cmatc( T, Pos )

% CMATC C * T * C' multiplication
%
%   T = CMATC( T, POS ) computes C * T * C', where the C 
%   matrix is a indicator matrix with one 1 on every line. 
%   The vector variable POS holds the position for the value
%   of one in every line in the C matrix.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 16.06.10-21.06.10

T = T( Pos, : );
T = T( :, Pos );