function [ isT, isR ] = istisr( ptype, nPol )

% ISTISR Is trigonometric and/or is real
%
%   This function checks the type of the polynomials.
%
%   INPUTS:  PTYPE, NPOL
%   
%   OUTPUTS: IST, ISR

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 15.12.08-21.08.10

% existence of trigonometric
% and/or real field(s)
isT = sparse( nPol, 1 );
isR = sparse( nPol, 1 );    

for i = 1 : nPol

    % check whether the number of variables  from 'p'
    % is equal with the sum of the number of trigonometric
    % and real variables from 'ptype'
    isT( i ) = isfield( ptype{ i }, 'trigonometric' );
    isR( i ) = isfield( ptype{ i }, 'real'          );
    % trigonometric
    if isT( i ) 
        % the field exists
        isT( i ) = ~isempty( ptype{ i }.trigonometric );
        if isT( i )
            % the field is not empty
            isT( i ) = ptype{ i }.trigonometric;
        end
    end
    % real
    if isR( i ) 
        % the field exists
        isR( i ) = ~isempty( ptype{ i }.real );
        if isR( i )
            % the field is not empty
            isR( i ) = ptype{ i }.real;
        end
    end
end