function xy = sdm2p3p( x, D, IsBRL, isEQForm, bsPnConstrOld, isBRL, BRLlenpol, BRLlencpol, KsPflqrs, KsPflqrsOld, nPolNU ) 

% SDM2P3P SeDuMi solution to POS3POLY solution
%
%   This function converts the SeDuMi solution to the POS3POLY solution.

% Copyright (C) 2008-2011 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 16.11.11

% the solution of the SeDuMi problem
% is "converted" to the solution of 
% the POS3POLY problem, if the problem
% was solved
if ~isempty( x )
    
    xy = D * x;
    
    if IsBRL
        if isEQForm
            Col1 = KsPflqrsOld;
            Col2 = KsPflqrs;
            for i = 1 : nPolNU
                if isBRL( i )
                    % insert filters back in their place,
                    % right before their the polynomials
                    
                    %      all the f variables          the filter                       the polynomials
                    xy = [ xy( 1 : KsPflqrs ); xy( Col1 + 1 : Col1 + BRLlencpol( i ) ); xy( Col2 + 1 : end ) ]; 
                    
                    Col1 = Col1 + BRLlencpol( i );
                    Col2 = Col2 + BRLlenpol( i ) + BRLlencpol( i );
                end
            end
            
            % eliminate filters inserted after Ks.f
            xy( KsPflqrsOld + 1 : KsPflqrsOld + sum( BRLlencpol ) ) = [ ];
        end
    end
    
    % if the problem was given in dual form,
    % we extract 'y' for the dual
    if ~isEQForm
        xy = xy( 1 : bsPnConstrOld );
    end
end