function varargout = p3p_demos(varargin)
% P3P_DEMOS M-file for p3p_demos.fig
%      P3P_DEMOS, by itself, creates a new P3P_DEMOS or raises the existing
%      singleton*.
%
%      H = P3P_DEMOS returns the handle to a new P3P_DEMOS or the handle to
%      the existing singleton*.
%
%      P3P_DEMOS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in P3P_DEMOS.M with the given input arguments.
%
%      P3P_DEMOS('Property','Value',...) creates a new P3P_DEMOS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before p3p_demos_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to p3p_demos_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help p3p_demos

% Last Modified by GUIDE v2.5 20-Jun-2010 22:57:05

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with SeDuMi Pol.  If not, see <http://www.gnu.org/licenses/>.

% Date: 10.01.10-09.02.10

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @p3p_demos_OpeningFcn, ...
                   'gui_OutputFcn',  @p3p_demos_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before p3p_demos is made visible.
function p3p_demos_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to p3p_demos (see VARARGIN)

% Choose default command line output for p3p_demos
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes p3p_demos wait for user response (see UIRESUME)
% uiwait(handles.demowindow);


% --- Outputs from this function are returned to the command line.
function varargout = p3p_demos_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in buttonstartdemo.
function buttonstartdemo_Callback(hObject, eventdata, handles)
% hObject    handle to buttonstartdemo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

SR = 1i;

set( handles.textcomputing, 'String', 'Computing...' );
drawnow;

% get tag for the selected radio button from the panel of demos
rGroupDemosTag = get( get( handles.paneldemo, 'SelectedObject' ), 'Tag' );
inputData = get( handles.tableinputparams, 'Data' );
switch rGroupDemosTag
    case 'radiobutton1'
        % min value trig. pol.
        
        % coefs. of the trig. pol.
        r = inputData;
        % min. trig. pol.
        [ mu ] = min_poly_value_general_trig( r );
        
        % check for empty fields
        XminStr = get( handles.editaxesparam1, 'String' );
        XmaxStr = get( handles.editaxesparam2, 'String' );
        if isempty( XminStr ) 
            msgbox( 'Xmin is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( XmaxStr )
            msgbox( 'Xmax is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
            
        % string to real number
        Xmin = str2double( XminStr );
        Xmax = str2double( XmaxStr );
        om = Xmin : 0.01 : Xmax;
        % number of values on the grid
        len = length( om );
        val = r( 1 );
        val = val( ones( len, 1 ) );
        for i = 1 : len
            for k = 2 : length( r )
                val( i ) = val( i ) + 2 * r( k ) * cos( ( k - 1 ) * om( i ) ); 
            end
        end
        plot( handles.axesgraph, om, val );
        set( get( gca, 'XLabel' ), 'String', '$\omega$',   ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'YLabel' ), 'String', '$R(\omega)$', ...
                                   'Interpreter', 'LaTeX',  ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', [ 'Minimum value of the polynomial $R(\omega)$: ' num2str( mu, 6 ) ], ...
                                  'Interpreter', 'LaTeX',  ...
                                  'FontSize', 13 );
        set( gca, 'XLim', [ Xmin Xmax ] );                       
    case 'radiobutton2'
        % min value real pol.
        
        % coefs. of the trig. pol.
        p = inputData;
        % min. real pol.
        [ mu ] = min_poly_value_general_real_2_7( p );
        
        % check for empty fields
        XminStr = get( handles.editaxesparam1, 'String' );
        XmaxStr = get( handles.editaxesparam2, 'String' );
        if isempty( XminStr ) 
            msgbox( 'Xmin is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( XmaxStr )
            msgbox( 'Xmax is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
            
        % string to real number
        Xmin = str2double( XminStr );
        Xmax = str2double( XmaxStr );
        t = Xmin : 0.01 : Xmax;
        % number of values on the grid
        len = length( t );
        val = p( 1 );
        val = val( ones( len, 1 ) );
        for i = 1 : len
            for k = 2 : length( p )
                val( i ) = val( i ) + p( k ) * t( i ) ^ ( k - 1 ); 
            end
        end
        plot( handles.axesgraph, t, val );
        set( get( gca, 'XLabel' ), 'String', '$t$',   ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'YLabel' ), 'String', '$P(t)$', ...
                                   'Interpreter', 'LaTeX',  ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', [ 'Minimum value of the polynomial $P(t)$: ' num2str( mu, 6 ) ], ...
                                  'Interpreter', 'LaTeX',  ...
                                  'FontSize', 13 );
        set( gca, 'XLim', [ Xmin Xmax ] );       
    case 'radiobutton3'
        % 1-D FIR filter design
        
        [ wth ] = lin_phase_fir( str2double( get( handles.editaxesparam1, 'String' ) ), ...
                                 str2double( get( handles.editaxesparam2, 'String' ) ) * pi, ...
                                 str2double( get( handles.editaxesparam3, 'String' ) ) * pi, ... 
                                 str2double( get( handles.editaxesparam4, 'String' ) ), ...
                                 str2double( get( handles.editaxesparam5, 'String' ) ) );
        % the frequencies
        f = 0 : 0.001 : 1;
        % freqz
        plot( f, 20 * log10( abs( polyval( [ flipud( wth( 2 : end ) ); wth ]', exp( -SR * pi * f ) ) ) ) );
        set( get( gca, 'XLabel' ), 'String', 'Frequency $(\omega/\pi)$',   ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'YLabel' ), 'String', 'Magnitude (dB)', ...
                                   'Interpreter', 'LaTeX',  ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', 'Frequency response of 1-D FIR filter', ...
                                  'Interpreter', 'LaTeX',  ...
                                  'FontSize', 13 );
    case 'radiobutton4'
        % 2-D min. value trig. pol
        
        % coefs. + degs.
        cdeg = get( handles.tableinputparams, 'Data' );
        
        % number of coefs and degs
        nc = size( cdeg, 1 );
        % degrees
        deg = cdeg( :, 2 : end );
        % coefficients
        coef = cell( nc, 1 );
        for i = 1 : nc
            coef{ i } = cdeg( i, 1 );
        end
        
        % degree of the polynomial
        n = max( abs( deg ) );        
        
        % the 'bsP' term
        bsP = sppol2fvec( n, deg, coef, 2 );
        
        % the minimum value
        [ mu ] = min_poly_value_multi_general_trig_3_5( n, bsP );
        
        % check for empty fields
        XminStr = get( handles.editaxesparam1, 'String' );
        XmaxStr = get( handles.editaxesparam2, 'String' );
        YminStr = get( handles.editaxesparam3, 'String' );
        YmaxStr = get( handles.editaxesparam4, 'String' );
        StepStr = get( handles.editaxesparam5, 'String' );
        if isempty( XminStr ) 
            msgbox( 'Xmin is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( XmaxStr )
            msgbox( 'Xmax is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( YminStr )
            msgbox( 'Ymin is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( YmaxStr )
            msgbox( 'Ymax is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( StepStr )
            msgbox( 'Step is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
            
        % string to real number
        Xmin = str2double( XminStr );
        Xmax = str2double( XmaxStr );
        Ymin = str2double( YminStr );
        Ymax = str2double( YmaxStr );
        Step = str2double( StepStr );
        % omega
        om1 = Xmin : Step : Xmax;
        om2 = Ymin : Step : Ymax;
        % number of values on the grid
        len1 = length( om1 );
        len2 = length( om2 );
        val = bsP( 1 );
        val = val( ones( len1, len2 ) );
        nTuple = ntuple( n, nch( n ), 1 );
        for i = 1 : len1
            for j = 1 : len2
                for k = 2 : length( bsP )
                    val( i, j ) = val( i, j ) + 2 * bsP( k ) * cos( ( nTuple( k, 1 ) ) * om1( i ) + ( nTuple( k, 2 ) ) * om2( j ) );
                end
            end
        end
        % plot mesh
        mesh( handles.axesgraph, om1, om2, val );
        set( get( gca, 'XLabel' ), 'String', '$\omega_1$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'YLabel' ), 'String', '$\omega_2$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'ZLabel' ), 'String', '$R(\omega_1, \omega_2)$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', [ 'Minimum value of the polynomial $R(\omega_1, \omega_2)$: ' num2str( mu, 6 ) ], ...
                                  'Interpreter', 'LaTeX',  ...
                                  'FontSize', 13 );
        set( gca, 'XLim', [ Xmin Xmax ] );       
        set( gca, 'YLim', [ Ymin Ymax ] );
    case 'radiobutton5'
        % min. value eig multi trig. pol.
        
        % coefs. + degs.
        cdeg = get( handles.tableinputparams, 'Data' );
        
        % number of coefs and degs
        nc = cdeg( 1, 1 );
        % size of coefs.
        K  = cdeg( 1, 2 );
        % degrees
        deg = cdeg( 2 : nc + 1, 1 : 2 );
        % coefficients
        coef = cell( nc, 1 );
        nc1 = nc + 1;
        for i = 1 : nc
            coef{ i } = cdeg( nc1 + ( i - 1 ) * 2 + 1 : nc1 + i * 2, 1 : 2 );
        end
        
        % degree of the polynomial
        n = max( abs( deg ) );        
        
        % the 'bsP' term
        bsP = sppol2fvec( n, deg, coef, 1, 0 );
        
        % the minimum value
        [ mu ] = min_matrix_poly_eigen_multi_general_trig( n, bsP, K );
        
        % check for empty fields
        XminStr = get( handles.editaxesparam1, 'String' );
        XmaxStr = get( handles.editaxesparam2, 'String' );
        YminStr = get( handles.editaxesparam3, 'String' );
        YmaxStr = get( handles.editaxesparam4, 'String' );
        StepStr = get( handles.editaxesparam5, 'String' );
        if isempty( XminStr ) 
            msgbox( 'Xmin is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( XmaxStr )
            msgbox( 'Xmax is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( YminStr )
            msgbox( 'Ymin is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( YmaxStr )
            msgbox( 'Ymax is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
        if isempty( StepStr )
            msgbox( 'Step is missing. Enter a value.', 'Missing Parameter.', 'error' );
            return;
        end
            
        % string to real number
        Xmin = str2double( XminStr );
        Xmax = str2double( XmaxStr );
        Ymin = str2double( YminStr );
        Ymax = str2double( YmaxStr );
        Step = str2double( StepStr );
        % omega
        om1 = Xmin : Step : Xmax;
        om2 = Ymin : Step : Ymax;
        % number of values on the grid
        len1 = length( om1 );
        len2 = length( om2 );
        
        % values for every frequency pair
        val = zeros( len1, len2 );
        
        % zero vector and matrix
        o = sparse( 2, 1 );
        O = sparse( 2, 2 );
        
        for i = 1 : len1
            for j = 1 : len2
                
                % init with zero matrix
                R = O;      
                % zero degree index, if exists
                idx = findvm( deg', o );
                
                if ~isempty( idx )
                    for k = 1 : nc
                        if k ~= idx
                            R = R + coef{ k }  * ( cos( om1( i ) + om2( j ) ) + SR * sin( om1( i ) + om2( j ) ) ) + ...
                                    coef{ k }' * ( cos( om1( i ) + om2( j ) ) - SR * sin( om1( i ) + om2( j ) ) );
                        else
                            R = R + coef{ k };
                        end  
                    end
                else
                    for k = 1 : nc
                        R = R + coef{ k }  * ( cos( om1( i ) + om2( j ) ) + SR * sin( om1( i ) + om2( j ) ) ) + ...
                                coef{ k }' * ( cos( om1( i ) + om2( j ) ) - SR * sin( om1( i ) + om2( j ) ) );
                    end
                end
                val( i, j ) = min( eig( R ) );
            end
        end
        % plot mesh
        mesh( handles.axesgraph, om1, om2, val );
        set( get( gca, 'XLabel' ), 'String', '$\omega_1/\pi$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'YLabel' ), 'String', '$\omega_2/\pi$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'ZLabel' ), 'String', '$\textnormal{min}(\textnormal{eig}(R(\omega_1, \omega_2)))$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', [ 'Minimum eigenvalue of the matrix polynomial $R(\omega_1, \omega_2)$: ' num2str( mu, 6 ) ], ...
                                  'Interpreter', 'LaTeX',  ...
                                  'FontSize', 13 );
        set( gca, 'XLim', [ Xmin Xmax ] );       
        set( gca, 'YLim', [ Ymin Ymax ] );
    case 'radiobutton6'
        n = [ str2double( get( handles.editaxesparam1, 'String' ) ) ...
              str2double( get( handles.editaxesparam2, 'String' ) ) ];     
        
        [ h ] = lin_phase_fir2d( n, str2double( get( handles.editaxesparam3, 'String' ) ) );
        % the frequencies
        f = -1 : 0.001 : 1;
        
        Bw = polyval2d( half2all2d( h, n ), exp( -SR * pi * f ), exp( -SR * pi * f ) );
        Aw = polyval2d( 1, exp( -SR * pi * f ), exp( -SR * pi * f ) );
        
        % frequency response
        Hw = Bw./Aw;
        
        % freqz
        mesh( f, f, 20 * log10( abs( Hw ) ) );
        set( get( gca, 'XLabel' ), 'String', 'Frequency $(\omega_1/\pi)$',   ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );        
        set( get( gca, 'YLabel' ), 'String', 'Frequency $(\omega_2/\pi)$',   ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );                       
        set( get( gca, 'ZLabel' ), 'String', 'Magnitude (dB)', ...
                                   'Interpreter', 'LaTeX',  ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', 'Frequency response of the 2-D FIR filter', ...
                                  'Interpreter', 'LaTeX',  ...
                                  'FontSize', 13 );
    case 'radiobutton7'
        % degree of the trig. pol.
        n = [ str2double( get( handles.editaxesparam1, 'String' ) ) ...
              str2double( get( handles.editaxesparam2, 'String' ) ) ...
              str2double( get( handles.editaxesparam3, 'String' ) ) ];     
        % passband error bound
        gp = str2double( get( handles.editaxesparam4, 'String' ) );
        % passband fan shape
        c  = str2double( get( handles.editaxesparam5, 'String' ) );  
        
        % filter design
        [ h ] = fir3d_lp( n, gp, c );
        % half coefficients to all coefficients
        H = half2all3d( h, n );
        % frequency response
        Hw = freqz3d( H);
        
        % frequency grid
        f = -1 : 1e-2 : 1;        
        plotf3d2d( Hw, 0 : 0.1 : 1, f, f, 1e-2, 1, 0, '', 0 );   
    case 'radiobutton8'
        % degree of trigonometric variable
        n2 = str2double( get( handles.editaxesparam1, 'String' ) );
        % degree of real variable
        K  = str2double( get( handles.editaxesparam2, 'String' ) );        
        % "hybrid" degree
        n  = [ n2 K ];
        % passband bound
        gp = str2double( get( handles.editaxesparam3, 'String' ) );
        % delta
        D  = str2double( get( handles.editaxesparam4, 'String' ) );
        
        tl = str2double( get( handles.editaxesparam5, 'String' ) );
        tu = str2double( get( handles.editaxesparam6, 'String' ) );
        t0 = ( tl + tu ) / 2;
        
        % adjustable filters
        G = adj_fir( n, gp, D, tl, tu, t0 );
        
        H = cell( K + 1, 1 );
        
        l = 1;
        u = n2 + 1;
        Shift = 0;
        for k = 0 : K
            H{ k + 1 } = [ G( u + Shift : -1 : l + 1 + Shift );  G( l + Shift : u + Shift ) ];
            Shift = Shift + n2 + 1;
        end        
        
        % draw filters;
        % we draw filters t = tl:Step:tu
        Step = 0.04;
        t = tl;
        G = zeros( length( H{ 1 } ), 1 );        
        tau = t - t0;
        Ht = H;
        for k = 0 : K
            Ht{ k + 1 } = Ht{ k + 1 } * tau ^ k;
        end        
        for k = 0 : K
            G = G + Ht{ k + 1 };
        end
        
        % the frequencies
        f = 0 : 0.001 : 1;
        % first filter
        plot( f, 20 * log10( abs( polyval( G', exp( -SR * pi * f ) ) ) ) );
        hold on
        % the rest of the filters
        for t = tl + Step : Step : tu
            G = zeros( length( H{ 1 } ), 1 );
            tau = t - t0;
            Ht = H;
            for k = 0 : K
                Ht{ k + 1 } = Ht{ k + 1 } * tau ^ k;
            end
            
            for k = 0 : K
                G = G + Ht{ k + 1 };
            end
            plot( f, 20 * log10( abs( polyval( G', exp( -SR * pi * f ) ) ) ) );
        end
        hold off     
        
        set( get( gca, 'XLabel' ), 'String', 'Normalized frequency $(\omega/\pi)$', ...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );                      
        set( get( gca, 'YLabel' ), 'String', 'Magnitude (dB)',...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
        set( get( gca, 'Title' ), 'String', 'Frequency responses of a family of adjustable filters',...
                                   'Interpreter', 'LaTeX', ...
                                   'FontSize', 12 );
    case 'radiobutton9'
        % data
        data = get( handles.tableinputparams, 'Data' );
        % number of columns
        s2 = size( data, 2 );
        % matrices defining the systems
        A0 = data( 1 : s2, 1 : s2 );
        A1 = data( s2 + 1 : 2 * s2, 1 : s2 );
        B  = data( 2 * s2 + 1 : 3 * s2, 1 : s2 );

        % ovTau
        ovTau = str2double( get( handles.editaxesparam1, 'String' ) );
        % Step
        Step  = str2double( get( handles.editaxesparam2, 'String' ) );    
        
        % orders of the Pade approximation
%         m1 = 3;
        m2 = 4;
%         m3 = 5;

        tau = Step : Step : ovTau;
        len = length( tau );
%         lambda1 = zeros( len, 1 );
        lambda2 = zeros( len, 1 );
%         lambda3 = zeros( len, 1 );
        lambda4 = zeros( len, 1 );
         
        for i = 1 : len
%             lambda1( i ) = neutral_stab( A0, A1, B, tau( i ), m1 );
            lambda2( i ) = neutral_stab( A0, A1, B, tau( i ), m2 );
%             lambda3( i ) = neutral_stab( A0, A1, B, tau( i ), m3 );
        end
        
        % test on a grid
        lambda4( 1 ) = check_datko_grid( A0, A1, B, tau( 1 ) );
        for i = 2 : len
            lambda4( i ) = min( check_datko_grid( A0, A1, B, tau( i ) ), lambda4( i - 1 ) );
        end

%         semilogy( tau, lambda1, ':'  ); 
%         hold on;
        semilogy( tau, lambda2, '-.' ); 
        hold on;
%         semilogy( tau, lambda3, '--' ); 
        semilogy( tau, lambda4, '-'  ); 
        hold off;  
        
        set( get( gca, 'XLabel' ), 'String', '$\widetilde{\tau}$', ...
                                   'Interpreter', 'LaTeX',         ...
                                   'FontSize', 12 );                      
        set( get( gca, 'YLabel' ), 'String', '$\log{\lambda_{max}}$',...
                                   'Interpreter', 'LaTeX',           ...
                                   'FontSize', 12 );
        
%         legend( '\lambda_1, m = 3',  '\lambda_1, m = 4', '\lambda_1, m = 5', '\lambda_m' );
        legend( '\lambda_1, m = 4', '\lambda_m' );
end

set( handles.textcomputing, 'String', 'Computing... Done !' );

function Min = check_datko_grid( A0, A1, B, ovTau )

% Test minimum eigenvalue of delay system on a grid.

% Author: Bogdan C. Sicleru

% j
SR = 1i;

Nw   = 100;
Ntau = 100;

v = zeros(Nw,Ntau);
w = logspace( 0, 2, Nw );
tau = 0 : ovTau / ( Ntau - 1 ) : ovTau;
for iw = 1 : Nw
  for it = 1 : Ntau
    P = SR * w( iw ) * ( eye( size( A0 ) ) - B * exp( -SR * w( iw ) * tau( it ) ) ) - A0 - A1 * exp( -SR * w( iw ) * tau( it ) );
    v( iw, it ) = min( eig( P * P' ) );
  end
end

Min = min( min( v ) );

% --- Executes during object creation, after setting all properties.
function demowindow_CreateFcn(hObject, eventdata, handles)
% hObject    handle to demowindow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% get screen size
scrSize = get(0,'ScreenSize');

% get window position and size
Position = get( hObject, 'Position' );

Position( 1 ) = ( scrSize( 3 ) - Position( 3 ) ) / 2;
Position( 2 ) = ( scrSize( 4 ) - Position( 4 ) ) / 2;

% set size of the demo window
set( hObject, 'Position', Position );


% --- Executes when selected object is changed in paneldemo.
function paneldemo_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in paneldemo 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% reset text computing
set( handles.textcomputing, 'String', '' );

% get Tag of selected radiobutton
switch get(eventdata.NewValue,'Tag') 
    case 'radiobutton1'
        % data in table
        set( handles.tableinputparams, 'Data', [ 6 -3 2  ]' );
        
        % Xmin & Xmax - set text
        set( handles.textaxesparam1, 'String', 'Xmin' );
        set( handles.textaxesparam2, 'String', 'Xmax' );
        % Xmin & Xmax - set values
        set( handles.editaxesparam1, 'String', '-3.14' );
        set( handles.editaxesparam2, 'String', '3.14'  );
        
        % hide the rest
        set( handles.textaxesparam3, 'String', '' );
        set( handles.textaxesparam4, 'String', '' );
        set( handles.textaxesparam5, 'String', '' );
        set( handles.textaxesparam6, 'String', '' );
        
        set( handles.editaxesparam3, 'Visible', 'off' );
        set( handles.editaxesparam4, 'Visible', 'off' );
        set( handles.editaxesparam5, 'Visible', 'off' );
        set( handles.editaxesparam6, 'Visible', 'off' );
        
        % demo description
        strDescr = { 'Computing the minimum value of a univariate trigonometric polynomial.', ...
                     ' ', 'The values from the table represent the coefficients ri of the (symmetric) polynomial, i.e. r0, r1, r2, etc. ' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', 3 );
    case 'radiobutton2'
        % data in table
        set( handles.tableinputparams, 'Data', [ 2 2 7 -2 1 ]' );
        
        % Xmin & Xmax - set text
        set( handles.textaxesparam1, 'String', 'Xmin' );
        set( handles.textaxesparam2, 'String', 'Xmax' );
        % Xmin & Xmax - set values
        set( handles.editaxesparam1, 'String', '-0.5' );
        set( handles.editaxesparam2, 'String', '0.5'  );
        
        % hide the rest
        % set textaxesparam 3,4,5 string empty
        set( handles.textaxesparam3, 'String', '' );
        set( handles.textaxesparam4, 'String', '' );
        set( handles.textaxesparam5, 'String', '' );
        set( handles.textaxesparam6, 'String', '' );
        % set editaxesparam 3, 4, 5 invisible 
        set( handles.editaxesparam3, 'Visible', 'off' );
        set( handles.editaxesparam4, 'Visible', 'off' );
        set( handles.editaxesparam5, 'Visible', 'off' );
        set( handles.editaxesparam6, 'Visible', 'off' );
        
        % demo description
        strDescr = { 'Computing the minimum value of a univariate real polynomial.', ...
                     ' ', 'The values from the table represent the coefficients pi of the polynomial, i.e. p0, p1, p2, etc. ' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', 5 );
    case 'radiobutton3'
        % data in table
        set( handles.tableinputparams, 'Data', '' );
        
        % Xmin & Xmax - set text
        set( handles.textaxesparam1, 'String', 'n'     );
        set( handles.textaxesparam2, 'String', 'wp/pi' );
        set( handles.textaxesparam3, 'String', 'ws/pi' );
        set( handles.textaxesparam4, 'String', 'gp'    );
        set( handles.textaxesparam5, 'String', 'gs'    );
        % set editaxesparam 3, 4, 5 visible
        set( handles.editaxesparam3, 'Visible', 'on' );
        set( handles.editaxesparam4, 'Visible', 'on' );
        set( handles.editaxesparam5, 'Visible', 'on' );
        % Xmin & Xmax - set values
        set( handles.editaxesparam1, 'String', '25'     );
        set( handles.editaxesparam2, 'String', '0.2'    );
        set( handles.editaxesparam3, 'String', '0.25'   );
        set( handles.editaxesparam4, 'String', '0.1'    );
        set( handles.editaxesparam5, 'String', '0.0158' );     
        
        % hide the rest
        set( handles.textaxesparam6, 'String' , ''    );
        set( handles.editaxesparam6, 'Visible', 'off' );
        
        % demo description
        strDescr = { '1-D FIR linear-phase low-pass filter design.', ...
                     ' ', ...
                     'n    - degree of the trigonometric polynomial, (2*n+1)-tap filter', ...
                     'wp - passband edge', ...
                     'ws - stopband edge', ...
                     'gp - passband error bound', ...
                     'gs - stopband error bound' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', '' );
    case 'radiobutton4'        
        % degrees
        cdeg( 1, 2 : 3 ) = [  0 0 ];
        cdeg( 2, 2 : 3 ) = [  1 0 ];
        cdeg( 3, 2 : 3 ) = [  2 0 ];
        cdeg( 4, 2 : 3 ) = [ -2 1 ];
        cdeg( 5, 2 : 3 ) = [ -1 1 ];
        cdeg( 6, 2 : 3 ) = [  0 1 ];
        cdeg( 7, 2 : 3 ) = [  1 1 ];
        cdeg( 8, 2 : 3 ) = [  2 1 ];        
        
        % coefficients of the polynomial
        cdeg(  1, 1 ) =  38;
        cdeg(  2, 1 ) =  18;
        cdeg(  3, 1 ) =  4;
        cdeg(  4, 1 ) =  1;
        cdeg(  5, 1 ) =  2;
        cdeg(  6, 1 ) =  1;
        cdeg(  7, 1 ) = -8;
        cdeg(  8, 1 ) = -5;

        % set data
        set( handles.tableinputparams, 'Data', cdeg );
        
        % Xmin & Xmax & Ymin & Ymax - set text
        set( handles.textaxesparam1, 'String', 'Xmin' );
        set( handles.textaxesparam2, 'String', 'Xmax' );
        set( handles.textaxesparam3, 'String', 'Ymin' );
        set( handles.textaxesparam4, 'String', 'Ymax' );
        % Xmin & Xmax & Ymin & Ymax - set values
        set( handles.editaxesparam1, 'String', '-3.14' );
        set( handles.editaxesparam2, 'String', '3.14'  );
        set( handles.editaxesparam3, 'Visible', 'on'   );
        set( handles.editaxesparam4, 'Visible', 'on'   );
        set( handles.editaxesparam3, 'String', '-3.14' );
        set( handles.editaxesparam4, 'String', '3.14'  );
        
        % Step for the plot
        set( handles.textaxesparam5, 'String', 'Step' );
        set( handles.editaxesparam5, 'Visible', 'on'  );
        set( handles.editaxesparam5, 'String', '0.05' );
        
        % hide the rest
        set( handles.textaxesparam6, 'String' , ''    );
        set( handles.editaxesparam6, 'Visible', 'off' );
        
        % demo description
        strDescr = { 'Computing the minimum value of a multivariate trigonometric polynomial.', ...
                     ' ', 'The values from the first column of the table represent the coefficients ri of the (symmetric) polynomial, from a halfspace, and the last two columns represent the pairs for the coefficients from the first column.', ...
                     ' ', ...
                     'Example. Taking a degree n = [2 1], the pairs of the considered coefficients are: (0, 0); (1, 0); (2, 0); (-2, 1); (-1, 1); (0, 1); (1, 1); (2, 1).', ...
                     ' ', ...
                     '''Step'' is the grid step used for plotting the values of the polynomial.' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', 8 );
    case 'radiobutton5'
        % degrees
        cdeg( 1, 1 ) = 5;
        cdeg( 1, 2 ) = 2;
        cdeg( 2, 1 : 2 ) = [  0 0 ];
        cdeg( 3, 1 : 2 ) = [  1 0 ];
        cdeg( 4, 1 : 2 ) = [ -1 1 ];
        cdeg( 5, 1 : 2 ) = [  0 1 ];
        cdeg( 6, 1 : 2 ) = [  1 1 ];
        
        % coefficients of the polynomial
        cdeg( 7  :  8, 1 : 2 ) = [ 4 0; ...
                                   0 4 ];
        cdeg( 9  : 10, 1 : 2 ) = [ 1 0; ...
                                   0 0 ];
        cdeg( 11 : 12, 1 : 2 ) = [ 0 0; ...
                                   0 0 ];
        cdeg( 13 : 14, 1 : 2 ) = [ 0 0;...
                                   0 1 ];
        cdeg( 15 : 16, 1 : 2 ) = [  0 0;...
                                   -1 0 ];

        % set data
        set( handles.tableinputparams, 'Data', cdeg );
        
        % Xmin & Xmax & Ymin & Ymax - set text
        set( handles.textaxesparam1, 'String', 'Xmin' );
        set( handles.textaxesparam2, 'String', 'Xmax' );
        set( handles.textaxesparam3, 'String', 'Ymin' );
        set( handles.textaxesparam4, 'String', 'Ymax' );
        % Xmin & Xmax & Ymin & Ymax - set values
        set( handles.editaxesparam1, 'String', '-3.14' );
        set( handles.editaxesparam2, 'String', '3.14'  );
        set( handles.editaxesparam3, 'Visible', 'on'   );
        set( handles.editaxesparam4, 'Visible', 'on'   );
        set( handles.editaxesparam3, 'String', '-3.14' );
        set( handles.editaxesparam4, 'String', '3.14'  );
        
        % Step for the plot
        set( handles.textaxesparam5, 'String', 'Step' );
        set( handles.editaxesparam5, 'Visible', 'on'  );
        set( handles.editaxesparam5, 'String', '0.05' );
        
        % hide the rest
        set( handles.textaxesparam6, 'String' , ''    );
        set( handles.editaxesparam6, 'Visible', 'off' );
        
        % demo description
        strDescr = { 'Computing the minimum eigenvalue of a multivariate trigonometric polynomial.', ...
                     ' ', 'The first line of the table contains the number of matrix coefficients and their size. The next lines contain the degrees of the coefficients, followed by the values of the matrix coefficients. ', ...
                     ' ', ...
                     '''Step'' is the grid step used for plotting the values of the polynomial.' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', 16 );
    case 'radiobutton6'
        % clear table
        set( handles.tableinputparams, 'Data', '' );
        
        % set textaxesparam 
        set( handles.textaxesparam1, 'String', 'n1' );
        set( handles.textaxesparam2, 'String', 'n2' );
        set( handles.textaxesparam3, 'String', 'gp' );
        set( handles.textaxesparam4, 'String', ''   );
        set( handles.textaxesparam5, 'String', ''   );
        % set editaxesparam 
        set( handles.editaxesparam1, 'Visible', 'on'  );
        set( handles.editaxesparam2, 'Visible', 'on'  );
        set( handles.editaxesparam3, 'Visible', 'on'  );
        set( handles.editaxesparam1, 'String' , '7'   );
        set( handles.editaxesparam2, 'String' , '7'   );
        set( handles.editaxesparam3, 'String' , '0.1' );
        set( handles.editaxesparam4, 'Visible', 'off' );
        set( handles.editaxesparam5, 'Visible', 'off' );   
        
        % hide the rest
        set( handles.textaxesparam6, 'String' , ''    );
        set( handles.editaxesparam6, 'Visible', 'off' );
        
        % demo description
        strDescr = { '2-D FIR linear-phase low-pass filter design.', ...
                     ' ', ...
                     'The optimization problem minimizes the stopband error.', ...
                     ' ', ...
                     '[n1 n2] - degree of the bivariate trigonometric polynomial, (2*n1+1)x(2*n2+1) filter', ...
                     'gp        - passband error bound' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', '' );
    case 'radiobutton7'
        % clear table
        set( handles.tableinputparams, 'Data', '' );
        
        % set textaxesparam 
        set( handles.textaxesparam1, 'String', 'n1' );
        set( handles.textaxesparam2, 'String', 'n2' );
        set( handles.textaxesparam3, 'String', 'n3' );
        set( handles.textaxesparam4, 'String', 'gp' );
        set( handles.textaxesparam5, 'String', 'c'  );
        % set editaxesparam 
        set( handles.editaxesparam1, 'Visible', 'on'  );
        set( handles.editaxesparam2, 'Visible', 'on'  );
        set( handles.editaxesparam3, 'Visible', 'on'  );        
        set( handles.editaxesparam4, 'Visible', 'on'  );
        set( handles.editaxesparam5, 'Visible', 'on'  );
        set( handles.editaxesparam1, 'String' , '4'   );
        set( handles.editaxesparam2, 'String' , '4'   );
        set( handles.editaxesparam3, 'String' , '4'   );
        set( handles.editaxesparam4, 'String' , '0.1' );
        set( handles.editaxesparam5, 'String' , '0.7' );
        
        % demo description
        strDescr = { '3-D FIR linear-phase low-pass filter design.', ...
                     ' ', ...
                     'The optimization problem minimizes the stopband error.', ...
                     ' ', ...
                     '[n1 n2 n3] - degree of the trivariate trigonometric polynomial, (2*n1+1)x(2*n2+1)x(2*n3+1) filter', ...
                     'gp             - passband error bound', ...
                     'c                - parameter to adjust the shape of the passband', ...
                     ' ', ...
                     'The ploted figures represent the filter for w3 = 0:0.1*pi:pi.'};
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', '' );
    case 'radiobutton8'
        % clear table
        set( handles.tableinputparams, 'Data', '' );
        
        % set textaxesparam 
        set( handles.textaxesparam1, 'String', 'n'  );
        set( handles.textaxesparam2, 'String', 'K'  );
        set( handles.textaxesparam3, 'String', 'gp' );
        set( handles.textaxesparam4, 'String', 'D'  );
        set( handles.textaxesparam5, 'String', 'tl' );
        set( handles.textaxesparam6, 'String', 'tu' );
        % set editaxesparam 
        set( handles.editaxesparam1, 'Visible', 'on'   );
        set( handles.editaxesparam2, 'Visible', 'on'   );
        set( handles.editaxesparam3, 'Visible', 'on'   );        
        set( handles.editaxesparam4, 'Visible', 'on'   );
        set( handles.editaxesparam5, 'Visible', 'on'   );
        set( handles.editaxesparam6, 'Visible', 'on'   );
        set( handles.editaxesparam1, 'String' , '13'   );
        set( handles.editaxesparam2, 'String' , '6'    );
        set( handles.editaxesparam3, 'String' , '0.01' );
        set( handles.editaxesparam4, 'String' , '0.25' );
        set( handles.editaxesparam5, 'String' , '0'    );
        set( handles.editaxesparam6, 'String' , '0.56' );
        
        % demo description
        strDescr = { 'Adjustable FIR filter design.', ...
                     ' ', ...
                     '[n K] - degree of the hybrid polynomial H(z,t); n for the trigonometric variable and K for the real one', ...
                     'gp    - passband error bound', ...
                     'tl,tu   - t in [tl, tu]', ...
                     'D      - adjust the transition band' };
        set( handles.textdescr, 'String', strDescr );
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', '' );
    case 'radiobutton9'
        % matrices defining the systems
        A0 = [ -0.9  0.2  ; ...
                0.1 -0.9 ];
        A1 = [ -1.1 -0.2  ; ...
               -0.1 -1.1 ];
        B  = [ -0.2  0    ; ...
                0.2 -0.1 ];   
            
        M = [ A0; A1; B ];
        
        % set data
        set( handles.tableinputparams, 'Data', M );
        
        % set textaxesparam 
        set( handles.textaxesparam1, 'String', 'tau_max' );
        set( handles.textaxesparam2, 'String', 'step'    );
        set( handles.textaxesparam3, 'String', ''        );
        set( handles.textaxesparam4, 'String', ''        );
        set( handles.textaxesparam5, 'String', ''        );
        set( handles.textaxesparam6, 'String', ''        );
        % set editaxesparam 
        set( handles.editaxesparam1, 'Visible', 'on'  );
        set( handles.editaxesparam2, 'Visible', 'on'  );
        set( handles.editaxesparam3, 'Visible', 'off' );
        set( handles.editaxesparam4, 'Visible', 'off' );
        set( handles.editaxesparam5, 'Visible', 'off' );
        set( handles.editaxesparam6, 'Visible', 'off' );
        set( handles.editaxesparam1, 'String' , '4'   );
        set( handles.editaxesparam2, 'String' , '0.3' ); 
        
       % demo description
        strDescr = { 'Neutral system stability test.', ...
                     ' ', ...
                     'Test the stability of the system', ...
                     ' ', ...
                     'dx(t)/dt - B*dx(t-tau)/dt = A0*x(t) + A1*x(t-tau).', ...
                     '', ...
                     'The function tests the stability of the system for tau=Step:Step:tau_max. The system is stable on [0, tau] if lambda(tau)>0. (Due to the numerical  errors a threshold must be considered.) The values from the table describe [A0; A1; B].', ...
                     ' ', ...
                     'This demo draws two plots: one for a Pade approximations and one for testing on a grid of values.' };
        set( handles.textdescr, 'String', strDescr ); 
        
        % numar of rows for data table
        set( handles.editnrrows, 'String', 6 );
end

cla  ( handles.axesgraph );
reset( handles.axesgraph );


% --- Executes during object creation, after setting all properties.
function tableinputparams_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tableinputparams (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% set initial data in table
set( hObject, 'Data', [ 6 -3 2  ]' );
set( hObject, 'ColumnEditable', true );


% --- Executes on button press in buttonsetnrrows.
function buttonsetnrrows_Callback(hObject, eventdata, handles)
% hObject    handle to buttonsetnrrows (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

nrrowsStr = get( handles.editnrrows, 'String' );
if ~isempty( nrrowsStr )
    nrows = str2double( nrrowsStr );
    data  = get( handles.tableinputparams, 'Data' );
    if ~isempty( data )
        drows = size( data, 1 );
        if nrows > drows
            if drows == 1
                data = data * eye( nrows, 1 );
            else
                data = wextend( 'ar', 'zpd', data, nrows - drows, 'd' );
            end
        elseif nrows < drows
            data = data( 1 : nrows, : );
        end
    else
        data = zeros( nrows, 1 );        
    end
    
    set( handles.tableinputparams, 'Data', data );
end


function editnrrows_Callback(hObject, eventdata, handles)
% hObject    handle to editnrrows (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editnrrows as text
%        str2double(get(hObject,'String')) returns contents of editnrrows as a double


% --- Executes during object creation, after setting all properties.
function editnrrows_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editnrrows (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function menufile_Callback(hObject, eventdata, handles)
% hObject    handle to menufile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menuexit_Callback(hObject, eventdata, handles)
% hObject    handle to menuexit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

delete( handles.demowindow );


% --- Executes when user attempts to close demowindow.
function demowindow_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to demowindow (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
delete(hObject);


% --------------------------------------------------------------------
function menuhelp_Callback(hObject, eventdata, handles)
% hObject    handle to menuhelp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menuabout_Callback(hObject, eventdata, handles)
% hObject    handle to menuabout (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

msgbox( { 'POS3POLY Demos (C) 2008, 2009, 2010', ' ', 'by Bogdan C. Sicleru and Bogdan Dumitrescu' }, 'About', 'help' );


function editaxesparam1_Callback(hObject, eventdata, handles)
% hObject    handle to editaxesparam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editaxesparam1 as text
%        str2double(get(hObject,'String')) returns contents of editaxesparam1 as a double


% --- Executes during object creation, after setting all properties.
function editaxesparam1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editaxesparam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set( hObject, 'String', '-3.14' );


function editaxesparam2_Callback(hObject, eventdata, handles)
% hObject    handle to editaxesparam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editaxesparam2 as text
%        str2double(get(hObject,'String')) returns contents of editaxesparam2 as a double


% --- Executes during object creation, after setting all properties.
function editaxesparam2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editaxesparam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set( hObject, 'String', '3.14' );


% --- Executes during object creation, after setting all properties.
function textaxesparam1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to textaxesparam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

set( hObject, 'String', 'Xmin' );


% --- Executes during object creation, after setting all properties.
function textaxesparam2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to textaxesparam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

set( hObject, 'String', 'Xmax' );


% --- Executes during object creation, after setting all properties.
function axesgraph_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axesgraph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axesgraph



function editaxesparam3_Callback(hObject, eventdata, handles)
% hObject    handle to editaxesparam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editaxesparam3 as text
%        str2double(get(hObject,'String')) returns contents of editaxesparam3 as a double


% --- Executes during object creation, after setting all properties.
function editaxesparam3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editaxesparam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set( hObject, 'Visible', 'off' );



function editaxesparam4_Callback(hObject, eventdata, handles)
% hObject    handle to editaxesparam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editaxesparam4 as text
%        str2double(get(hObject,'String')) returns contents of editaxesparam4 as a double


% --- Executes during object creation, after setting all properties.
function editaxesparam4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editaxesparam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set( hObject, 'Visible', 'off' );


function editaxesparam5_Callback(hObject, eventdata, handles)
% hObject    handle to editaxesparam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editaxesparam5 as text
%        str2double(get(hObject,'String')) returns contents of editaxesparam5 as a double


% --- Executes during object creation, after setting all properties.
function editaxesparam5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editaxesparam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

set( hObject, 'Visible', 'off' );



function editaxesparam6_Callback(hObject, eventdata, handles)
% hObject    handle to editaxesparam6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editaxesparam6 as text
%        str2double(get(hObject,'String')) returns contents of editaxesparam6 as a double


% --- Executes during object creation, after setting all properties.
function editaxesparam6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editaxesparam6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes during object creation, after setting all properties.
function textdescr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to textdescr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% demo description
strDescr = { 'Computing the minimum value of a univariate trigonometric polynomial.', ...
             ' ', 'The values from the table represent the coefficients ri of the (symmetric) polynomial, i.e. r0, r1, r2, etc. ' };
set( hObject, 'String', strDescr );


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over buttonsetnrrows.
function buttonsetnrrows_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to buttonsetnrrows (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
