function p3p_setup

% P3P_SETUP Setup for POS3POLY library
%
%   This script will make the setup required for the POS3POLY
%   library: it will add to the Matlab path the POS3POLY 
%   subdirectories 'core', 'utils' and 'examples', 'demos',
%   'core|cvx', 'examples|cvx' and save the new path.
%
%   See also pos3poly, sos_pol.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of SeDuMi Pol.
% 
% SeDuMi Pol is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% SeDuMi Pol is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with SeDuMi Pol.  If not, see <http://www.gnu.org/licenses/>.

% Date: 16.12.08-31.03.14

CURR_DIR = pwd;

SDIRS = { 'core', 'utils', 'examples', 'demos', ...
          strcat( strcat( 'core', filesep ), 'cvx' ), ...
          strcat( strcat( 'examples', filesep ), 'cvx' ) };
NSDIRS = length( SDIRS );

fprintf( '\n' );
disp( 'Prepending SeDuMi Pol directories to MATLAB path... ' );

for i = 1 : NSDIRS
    NewDir = strcat( CURR_DIR, filesep, SDIRS{ i } );
    path( NewDir, path );
    disp( NewDir  );
end

fprintf( '\n' );
disp( 'Saving path...' );

ret = savepath;
if ~ret
    disp( 'Path saved successfully.');
    fprintf( '\nSetup completed successfully !\n' );
else
    fprintf('\nWarning: Path could not be saved and is valid only for the current session; check user rights.\n');
end