function [ ret ] = cf( expr, val1, val2 )

% CF Conditional Function
%
%   [ RET ] = CF( EXPR, VAL1, VAL2 ) returns VAL1
%   if EXPR expression is true and VAL2 otherwise.
%   
%   The function acts like the conditional operator 
%   '?' found in some programming languages.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 3.11.08

% check the number of 
% input arguments
if nargin ~= 3
    error( 'Incorrect number of input arguments.' );
end

% check boolean value
% of 'expr'
if expr
    % TRUE
    ret = val1;
else
    % FALSE
    ret = val2;
end