function [ i ] = eqm( A, B )

% EQM Matrix equality
%
%   [ I ] = EQM( A, B ) returns 1 if the matrices A and B 
%   are equal and 0 if not.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 18.05.09

% size for the matrices
[ m1, n1 ] = size( A );
[ m2, n2 ] = size( B );

% check equal size for
% the matrices
if m1 ~= m2 || n1 ~= n2
    error( 'The two input matrices must be of equal size.' );
end

% check if equal
if ~nnz( A - B )
    % yes
    i = 1;
else
    % no
    i = 0;
end