function i = findvm( M, v )

% FINDVM Find vector in matrix
%
%   I = FINDVM( M, V ) returns in the vector I the indexes of the
%   columns of the matrix M which are equal with the vector V.
%
%   See also find.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 28.03.09-11.07.09

vLen = length( v );

if vLen ~= size( M, 1 )
    error( 'Matrix and vector size must agree.' );
end

% for one value to seach you
% do not use 'all' because it
% searches in vector, not on
% columns of a matrix
if vLen == 1
    i = find(      ( repmat( reshape( v, length( v ), 1 ), 1, size( M, 2 ) ) == M )   );
else
    i = find( all( ( repmat( reshape( v, length( v ), 1 ), 1, size( M, 2 ) ) == M ) ) );
end