function RET = iseven( N )

% ISEVEN True for even numbers
%
%   ISEVEN( N ) returns 1 if N is an even number and 0 otherwise.
%
%   ISEVEN( N ) returns a sparse matrix with ones corresponding
%   to the even values of the matrix N.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 13.11.08-7.07.09

% size for N
[ m, n ] = size( N );

% 'iseven' matrix
RET = sparse( m, n );

% compute RET matrix
for i = 1 : m
    for j = 1 : n
        RET( i, j ) = cf( mod( N( i, j ), 2 ), 0, 1 );
    end
end