function [ nC ] = nch( n )

% NCH Number of coefficients in a halfspace
%
%   [ NC ] = NCH( N ) returns in the variable NC
%   the number of coefficients of a multivariate 
%   trigonometric polynomial of degree N. 
%   (N is a vector.)
%
%   See also nchp, sumn.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 10.03.09

% return number of coefficients
% in halfspace
nC = ( 1 + prod( 2 * n + 1 ) ) / 2;