function A = onesc( m, n, v )

% ONESC Custom ones
%
%   A = ONESC( M, N, V ) returns the matrix A of size MxN
%   with ones on the indexes with values from the vector V
%   and zeros elsewhere.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 12.06.09

% number of elements
% in the marix
N = m * n;

% check nr. of elements in 'v' 
assert( N >= length( v ), 'Two many elements in ''v''.'  );
% check non-empty vector 'v'
assert( ~isempty( v ), 'Vector ''v'' must be non-empty.' );
% check maximum value in 'v'
assert( N >=    max( v ), 'Value too high in ''v''.'     );

% init matrix 
A = sparse( m, n );
% fill with 1s
A( v ) = 1;