function [ hours, minutes, seconds ] = sec2hour( t )

% SEC2HOUR Seconds to hours
%
%   [ HOURS, MINUTES, SECONDS ] = SEC2HOUR( T ) transforms
%   T seconds in HOURS, MINUTES and SECONDS.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date:   4.02.09

t       = round( t ); % we round the number of seconds
seconds = mod( t, 60 ); % seconds
t       = t -seconds;
t       = t / 60; % minutes
if t >= 60 % if t >= 60 then we have hours too, otherwise hours is 0
    minutes = mod( t, 60 ); % minutes
    hours   = ( t - minutes ) / 60; % number of hours
else
    minutes = t; % minutes
    hours   = 0; % hours = 0 if minutes < 60
end