function [ s ] = sumn( n )

% SUMN Sum of the first natural numbers
%
%   [ S ] = SUMN( N ) returns the result of the
%   following formula:
%
%   S = N * ( N + 1 ) / 2
%
%   If N is a natural number this represents the 
%   sum of the first N natural numbers.
%
%   See also nch.

% Copyright (C) 2008, 2009, 2010 Bogdan C. Sicleru, Bogdan Dumitrescu
% 
% This file is part of POS3POLY.
% 
% POS3POLY is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% POS3POLY is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with POS3POLY.  If not, see <http://www.gnu.org/licenses/>.

% Date: 9.11.08

% cumpute 's'
s = n * ( n + 1 ) / 2;